module.exports.parse_required_vars_command = function(command, check_command){
  let has_required_vars = true;

  command.required_vars.forEach((required_var) => {
    if(!check_command.vars[required_var]){
      has_required_vars = false;
    }else{
      command.command = command.command.replace('$' + required_var, check_command.vars[required_var]);

      if(command.debug_command){
        command.debug_command = command.debug_command.replace('$' + required_var, check_command.vars[required_var]);
      }
    }
  });

  if(has_required_vars){
    return command;
  }else{
    return undefined;
  }
}

module.exports.parse_multiline_stdout = function(config, host, check_command, stdout, error_or_warning, notification_callback){
  let k = 0;
  let lines = stdout.split('\n');

  if(config.debug){
    console.log(stdout);
    console.log(lines);
  }

  lines.forEach((line) => {
    if(line){
      let modified_check_command = JSON.parse(JSON.stringify(check_command));
      modified_check_command.unique_name = check_command.unique_name + '-' + k;

      notification_callback(host, modified_check_command, error_or_warning.state, error_or_warning.message, line);

      k++;
    }
  });
}

module.exports.parse_base64_command = function(command){
  if(!command.command){
    if(command.command_base64){
      command.command = (Buffer.from(command.command_base64, 'base64')).toString('ascii');
    }
  }

  if(!command.debug_command){
    if(command.debug_command_base64){
      command.debug_command = (Buffer.from(command.debug_command_base64, 'base64')).toString('ascii');
    }
  }

  return command;
}
